Connection failure because of mismatched TDS version

Connection failure because of mismatched TDS version

  • Comments 2

Some customers have reported connection failure because of wrong TDS version.

 

The client application gets the following error message: (or similar depends on the protocol used)

A connection was successfully established with the server, but then an error occurred during the login process. (provider: Shared Memory Provider, error: 0 - No process is on the other end of the pipe.) (Microsoft SQL Server, Error: 233)

 

 

When you check the errorlog of your SQL Server, you see the following error message:

 

The Tabular Data Stream (TDS) version 0x730a0003 of the client library used to open the connection is unsupported or unknown. The connection has been closed. [CLIENT: x.x.x.x]

Error: 17802, Severity: 20, State: 1.

 

Depends on your client version, 0x730a0003 could be 0x73080003 or 0x73090003 as well.

 

The failure only happens when connecting to SQL Server 2008 CTP releases. Usually the client involved uses SQLClient which is part of .Net Framework. The reason here is that we don't supported connection between intermediate TDS version. SNAC usually ships with SQL Server and they are managed to be in the same TDS level. If you download SNAC CTP separately or make connection across machines with different level of SNAC, you may also see similar error. As a background, for 0x730a0003 TDS version, 73 represents TDS major version 7.3, 0x03 is the minor version for TDS7.3, 0xa is the intermediate TDS version number.

 

We have shipped the following intermediate TDS version for SQL Server 2008.

 

·         08 first 7.3 TDS version in Katmai  (Shipped with Katmai CTP3 --Jun 2007--, Orcas Beta1)

·         09 TVP (Table Value Parameter) and NewDateTime (Shipped with Katmai CTP4 --build #1049, July 2007--, Orcas Beta2)

·         0A Large UDT (Shipped with Katmai CTP5 --build #1185, Nov 2007--, Orcas RTM, Vista SP1)

·         0B SparseColumn (Shipped with Katmai CTP6 --build #1321 Feb 2008-- )

 

All .Net Framework 3.5 released after Orcas RTM is on 0x0A TDS level. All SQL Server 2008 release after CTP6 (including RC0 and RTM) is on 0x0B TDS level. Connection can only be made between same TDS intermediate version, with one exception:

0B level of SQL Server can also accept 0A level of client. Thus, Orcas RTM can connect to SQL Server 2008 RTM without problem.

 

With the mechanism in place, it's fairly easy to tell which client can connect to which server. e.g. connection from Orcas RTM to Katmai CTP4 server would fail.

 

Orcas RTM contains .Net Framework 3.5. Some words worth to be quoted here: "As with .NET Framework 3.0, version 3.5 uses the CLR of version 2.0. In addition, it installs .NET Framework 2.0 SP1 and .Net Framework 3.0 SP1."

 

As a final note, you should not see the failure when there is no CTP server or beta version of client involved. Connection between RTM of client and server is always guaranteed.

 

 

Xinwei Hong, SQL Server Protocols
Disclaimer: This posting is provided "AS IS" with no warranties, and confers no rights

Leave a Comment
  • Please add 4 and 1 and type the answer here:
  • Post
  • A colleague (Cornel Sukalla) asked me what the protocol_version in sys.dm_exec_connections is all about.

  • Hi,

    It's the negotiated TDS version in DWORD format. You can run the following to get the exact value:

    select cast(protocol_version as varbinary(4)) from sys.dm_exec_connections

    Thanks,

    Xinwei

Page 1 of 1 (2 items)